var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import React, { useEffect, useState } from "react";
import { PassSDK, RedeemAndRevealSDK, SimultaneousRevealSDK, UseCase, } from "@inkerlabs/sdk";
import Context from "./context";
import { WagmiConfig, createClient, chain, configureChains, useSigner, } from "wagmi";
import { publicProvider } from "wagmi/providers/public";
import { alchemyProvider } from "wagmi/providers/alchemy";
import { CoinbaseWalletConnector } from "wagmi/connectors/coinbaseWallet";
import { MetaMaskConnector } from "wagmi/connectors/metaMask";
import { WalletConnectConnector } from "wagmi/connectors/walletConnect";
import { InjectedConnector } from "wagmi/connectors/injected";
import { Buffer } from "buffer";
import { useConnect } from "wagmi";
// polyfill Buffer for client
if (!window.Buffer) {
    window.Buffer = Buffer;
}
var _a = configureChains([chain.mainnet, chain.rinkeby, chain.polygon, chain.polygonMumbai], [publicProvider(), alchemyProvider()]), chains = _a.chains, provider = _a.provider, webSocketProvider = _a.webSocketProvider;
export var availableChains = chains;
// Set up client
var client = createClient({
    autoConnect: false,
    connectors: [
        new MetaMaskConnector({ chains: chains }),
        new CoinbaseWalletConnector({
            chains: chains,
            options: {
                appName: "wagmi",
            },
        }),
        new WalletConnectConnector({
            chains: chains,
            options: {
                qrcode: true,
            },
        }),
    ],
    provider: provider,
    webSocketProvider: webSocketProvider,
});
function _Provider(props) {
    var children = props.children;
    var _a = useState({}), context = _a[0], setContext = _a[1];
    var signer = useSigner().data;
    var connect = useConnect().connect;
    useEffect(function () {
        if (signer) {
            var sdk = void 0;
            switch (props.useCase) {
                case UseCase.PASS:
                    sdk = new PassSDK(props.config, signer);
                    break;
                case UseCase.RR:
                    sdk = new RedeemAndRevealSDK(props.config, signer);
                    break;
                case UseCase.SR:
                    sdk = new SimultaneousRevealSDK(props.config, signer);
                    break;
            }
            setContext({ sdk: sdk, error: undefined });
        }
        else {
            var sdk = void 0;
            switch (props.useCase) {
                case UseCase.PASS:
                    sdk = new PassSDK(props.config);
                    break;
                case UseCase.RR:
                    sdk = new RedeemAndRevealSDK(props.config);
                    break;
                case UseCase.SR:
                    sdk = new SimultaneousRevealSDK(props.config);
                    break;
            }
            setContext({
                sdk: sdk,
            });
        }
    }, [props.config]);
    useEffect(function () {
        var _a;
        if (signer) {
            (_a = context.sdk) === null || _a === void 0 ? void 0 : _a.updateSigner(signer);
        }
    }, [signer]);
    React.useEffect(function () {
        connect({
            connector: new InjectedConnector({
                chains: availableChains,
                options: {
                    shimDisconnect: true,
                },
            }),
        });
    }, []);
    if (!context.sdk && !context.error) {
        return null;
    }
    return _jsx(Context.Provider, __assign({ value: context }, { children: children }), void 0);
}
export default function Provider(_a) {
    var children = _a.children, props = __rest(_a, ["children"]);
    return (_jsx(WagmiConfig, __assign({ client: client }, { children: _jsx(_Provider, __assign({}, props, { children: children }), void 0) }), void 0));
}
