import useSDKFactory from './useSDKFactory';
import { UseCase, } from '@inkerlabs/sdk';
import { useAccount } from 'wagmi';
export default function useBuyPrivateFactory(useCase) {
    return function useBuyPrivate() {
        var sdk = useSDKFactory()();
        useAccount();
        switch (useCase) {
            case UseCase.PASS:
                var passSDK_1 = sdk;
                return (function (assetId, amount) {
                    return passSDK_1.buyPrivate(assetId, amount);
                });
            case UseCase.RR:
                var rrSDK_1 = sdk;
                return (function (amount) { return rrSDK_1.buyPrivate(amount); });
            case UseCase.SR:
                var srSDK_1 = sdk;
                return (function (amount) { return srSDK_1.buyPrivate(amount); });
            default:
                throw new Error("Unknown use case ".concat(useCase));
        }
    };
}
