import { useEffect, useState } from 'react';
import useSDK from '../common/useSDKFactory';
import { RRListenable } from '@inkerlabs/sdk';
import { useAccount } from 'wagmi';
export default function useRedeemableBalance() {
    var sdk = useSDK()();
    useAccount();
    var _a = useState(undefined), balance = _a[0], setBalance = _a[1];
    var _b = useState(undefined), error = _b[0], setError = _b[1];
    var id;
    useEffect(function () {
        if (id) {
            sdk.unlisten(id, RRListenable.REDEEMABLE);
        }
        id = sdk.listen(RRListenable.REDEEMABLE, function (err, _balance) {
            setError(err);
            setBalance(_balance);
        });
    }, []);
    // Emulate componentWillUnmount
    useEffect(function () {
        return function () {
            if (id) {
                sdk.unlisten(id, RRListenable.REDEEMABLE);
            }
        };
    }, []);
    return [balance, error];
}
